UNIT TheMaxFile;

INTERFACE

USES Dos;

Procedure Del(FileName: String);
{  䠩 FileName }
Function  Exist(FileName: String): Boolean;
{ ஢ 稥 䠩 FileName }
Procedure CopyFile(FN1,FN2: String);
{  䠩 FN1  䠩 FN2 }
Procedure ZeroFile(FileName: String);
{  䠩   0 (㫨 騩) }
Procedure SkipBytes(VAR Fil: Text; Bytes: Integer);
{  㪠 ⢮   ⥪⮢ 䠩 }
Function  XExist(FileName: String): Integer;
{ ஢ 稥 䠩, 頥  訡 }
Function FileSize(FileName: String): LongInt;
{ 뢠 ࠧ 䠩 }
Procedure CopyFileWS(FN1,FN2: String; Skip: LongInt);
{  䠩 FN1  FN2  ᪨쥬  Skip . }
Procedure CopyFileBlock(FN1,FN2: String; BB,BE: LongInt);
{    . BB, BE  䠩 FN1  FN2 }
Procedure AppendFile(FN1,FN2: String);
{  䠩 FN1  䠩 FN2 }
Function AddSlash(StrIn: String): String;
{  '\'    }


IMPLEMENTATION

CONST FileBuffer=$0FFFF;  {   ஢ 䠩 }

Procedure Del(FileName: String);
Assembler;
VAR PathBuffer: Array[0..78] of Char;
ASM
 PUSH DS
 CLD
 MOV AX,[WORD PTR FileName+2]
 MOV SI,[WORD PTR FileName]
 LEA DI,PathBuffer
 MOV DX,DI
 MOV DS,AX
 MOV BX,SS
 MOV ES,BX
 LODSB
 XOR AH,AH
 MOV CX,AX
 CMP CL,79
 JBE @@MoveThem
 MOV CL,79
@@MoveThem:
 SHR CX,1
 JNC @@DoWords
 MOVSB
@@DoWords:
 REP MOVSW
 MOV [BYTE PTR ES:DI],0H
 MOV AX,ES
 MOV DS,AX
 MOV AH,41H
 MOV CL,0
 INT 21H
 POP DS
END;

Function Exist(FileName: String): Boolean;
VAR F: File;
BEGIN
{$I-}
 Assign(F, FileName);
 Reset(F);
 Close(F);
{I+}
 Exist:=(IOResult = 0) and (FileName <> '');
END;

Procedure CopyFile(FN1,FN2: String);
TYPE Bufer=Array[1..FileBuffer] of Char;
VAR FromF, ToF: File;
    NumRead, NumWritten: Word;
    Buf: ^Bufer;
BEGIN
 Assign(FromF, FN1);
 Reset(FromF, 1);
 Assign(ToF, FN2);
 ReWrite(ToF, 1);
 New(Buf);
 REPEAT
  BlockRead(FromF, Buf^, SizeOf(Buf^), NumRead);
  BlockWrite(ToF, Buf^, NumRead, NumWritten);
 UNTIL (NumRead = 0) or (NumWritten <> NumRead);
 Dispose(buf);
 Close(FromF);
 Close(ToF);
END;

Procedure ZeroFile(FileName: String);
VAR F: Text;
BEGIN
Assign(F,FileName);
ReWrite(F);
Close(F);
END;

Procedure SkipBytes(VAR Fil: Text; Bytes: Integer);
VAR I:  Integer;
    Ch: Char;
BEGIN
{$F-}
FOR I:=1 to Bytes do Read(Fil,Ch);
{$F+}
END;

Function XExist(FileName: String): Integer;
VAR
  FS: SearchRec;
BEGIN
 FindFirst(FileName,AnyFile,FS);
 XExist:=DosError;
END;

Function FileSize(FileName: String): LongInt;
VAR Z: SearchRec;
BEGIN
FindFirst(FileName,AnyFile,Z);
IF DosError=0 then BEGIN
 FileSize:=Z.Size;
END;
END;

Procedure CopyFileWS(FN1,FN2: String; Skip: LongInt);
type
  bufer=array[1..FileBuffer] of Char;
VAR FromF, ToF: file;
    NumRead, NumWritten: Word;
    Buf: ^bufer;
    Sk: LongInt;
BEGIN
 Assign(FromF, FN1);
 Reset(FromF, 1);
 Assign(ToF, FN2);
 ReWrite(ToF, 1);
 New(buf);
 Sk:=Skip;
 While Sk>SizeOf(Buf^) do BEGIN
  BlockRead(FromF, Buf^, SizeOf(Buf^), NumRead);
  Sk:=Sk-SizeOf(Buf^);
 END;
 BlockRead(FromF, Buf^, Sk, NumRead);
 REPEAT
  BlockRead(FromF, Buf^, SizeOf(Buf^), NumRead);
  BlockWrite(ToF, Buf^, NumRead, NumWritten);
 UNTIL (NumRead = 0) or (NumWritten <> NumRead);
 Dispose(buf);
 Close(FromF);
 Close(ToF);
END;

Procedure CopyFileBlock(FN1,FN2: String; BB,BE: LongInt);
type
  bufer=array[1..FileBuffer] of Char;
VAR FromF, ToF: file;
    NumRead, NumWritten: Word;
    Buf: ^bufer;
    Sk: LongInt;
BEGIN
 Assign(FromF, FN1);
 Reset(FromF, 1);
 Assign(ToF, FN2);
 ReWrite(ToF, 1);
 New(buf);
 Sk:=BB;
 While Sk>SizeOf(Buf^) do BEGIN
  BlockRead(FromF, Buf^, SizeOf(Buf^), NumRead);
  Sk:=Sk-SizeOf(Buf^);
 END;
 BlockRead(FromF, Buf^, Sk, NumRead);
 REPEAT
  BlockRead(FromF, Buf^, SizeOf(Buf^), NumRead);
  BlockWrite(ToF, Buf^, NumRead, NumWritten);
 UNTIL (NumRead = 0) or (NumWritten <> NumRead);
 Dispose(buf);
 Seek(ToF,BE);
 Truncate(ToF);
 Close(FromF);
 Close(ToF);
END;

Procedure AppendFile(FN1,FN2: String);
type
  bufer=array[1..FileBuffer] of Char;
VAR FromF, ToF: file;
    NumRead, NumWritten: Word;
    Buf: ^bufer;
BEGIN
 Assign(FromF, FN1);
 Reset(FromF, 1);
 Assign(ToF, FN2);
 IF Exist(FN2) then BEGIN Reset(ToF,1); Seek(ToF,FileSize(FN2)); END ELSE ReWrite(ToF, 1);
 New(buf);
 REPEAT
  BlockRead(FromF, Buf^, SizeOf(Buf^), NumRead);
  BlockWrite(ToF, Buf^, NumRead, NumWritten);
 UNTIL (NumRead = 0) or (NumWritten <> NumRead);
 Dispose(buf);
 Close(FromF);
 Close(ToF);
END;

Function AddSlash(StrIn: String): String;
BEGIN
 IF StrIn[Length(StrIn)]<>'\' then AddSlash:=StrIn+'\' ELSE AddSlash:=StrIn;
END;

END.